﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace RibbonTest
{
    /// <summary>
    /// ViewLayer: Klasse für Activity-Views
    /// </summary>
    public class ActivityViewModel
    {
        /// <summary>
        /// Klasse für Activity-Views eines Mandanten
        /// </summary>
        /// <param name="client">Mandant</param>
        public ActivityViewModel( ActivityContainer activities )
        {
            // Aktivitäten des Mandanten laden
            this.activities = activities;
            this.bindingList = new ActivityBindingList( this.activities );
        }

        /// <summary>
        /// Liste mit allen Aktivitäten
        /// </summary>
        ActivityContainer activities = null;
        public ActivityContainer Activities
        {
            get { return activities; }
        }

        /// <summary>
        /// Binding-List mit allen Aktivitäten
        /// </summary>
        private ActivityBindingList bindingList;
        public ActivityBindingList BindingList
        {
            get { return bindingList; }
        }

    }
}
