﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace RibbonTest
{
    // ----------------------------------------------------------------------------------------------------------------------------
    public class OrgBase
    {
        public enum OrgTypes
        {
            None, Client, Department, Employee
        }

        private OrgTypes orgType = OrgTypes.None;
        private int orgId = 0;
        private string orgName = string.Empty;
        private OrgBase parent = null;

        public OrgBase Parent
        {
            get { return parent; }
            set { parent = value; }
        }

        public string OrgName
        {
            get { return orgName; }
            set { orgName = value; }
        }

        public int OrgId
        {
            get { return orgId; }
            set { orgId = value; }
        }

        public OrgTypes OrgType
        {
            get { return orgType; }
            set { orgType = value; }
        }

        public OrganisationContainer Childs
        {
            get { return GetChilds(); }
        }

        protected virtual OrganisationContainer GetChilds()
        {
            return null;
        }

        public OrgBase( OrgBase parent, int orgId, string orgName, OrgTypes orgType )
        {
            this.orgId = orgId;
            this.orgName = orgName;
            this.orgType = orgType;
        }

    }

    // ----------------------------------------------------------------------------------------------------------------------------
    public class OrgComposite : OrgBase
    {
        public OrgComposite( OrgBase parent, int orgId, string orgName, OrgTypes orgType )
            :base(parent,orgId,orgName,orgType)
        {
            this.childs = new OrganisationContainer();
        }

        protected OrganisationContainer childs = null;

        protected override OrganisationContainer GetChilds()
        {
            return this.childs;
        }

    }

    // ----------------------------------------------------------------------------------------------------------------------------
    public class OrgClient : OrgComposite
    {
        public OrgClient( int orgId, string orgName )
            : base( null, orgId, orgName, OrgTypes.Client )
        {
        }
    }

    // ----------------------------------------------------------------------------------------------------------------------------
    public class OrgDepartment : OrgComposite
    {
        public OrgDepartment( OrgBase parent, int orgId, string orgName )
            :base(parent, orgId,orgName, OrgTypes.Department )
        {
        }
    }


    // ----------------------------------------------------------------------------------------------------------------------------
    public class OrgEmployee : OrgBase
    {
        public OrgEmployee( OrgBase parent, int orgId, string orgName )
            :base(parent,orgId,orgName,OrgTypes.Employee)
        {
        }
    }

    // ----------------------------------------------------------------------------------------------------------------------------
    public class OrganisationContainer : List<OrgBase>
    {
        public OrganisationContainer()
        {
        }
    }

}
